[!if=(FileExists, "FALSE")]
// [!CPPName] : Implementation of [!ClassName]

#include "stdafx.h"
#include "[!ProjectName].h"
#include "[!HeaderName]"
[!else]
[!AddIncludeFile(TargetFile, "stdafx.h")]
[!AddStringToSymbol(ProjectName.h, ProjectName, ".h")]
[!AddIncludeFile(TargetFile, ProjectName.h)]
[!AddIncludeFile(TargetFile, HeaderName)]
[!endif]
[!crlf]

/////////////////////////////////////////////////////////////////////////////
// [!ClassName]
[!crlf]
[!if=(ErrorInfoEnabled, "TRUE")]
STDMETHODIMP [!ClassName]::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_[!InterfaceName]
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}
[!endif]

[!crlf]
#define _VERSION 1
BEGIN_FUNCTOID_MAP([!ClassName], _VERSION, FUNCTOID_FIRST_USER_FUNCID)
   BEGIN_FUNCTOID(L"[!ShortName] #1", FUNC_CATEGORY_UNKNOWN)
        FUNCTOID_TOOLTIP(L"Custom functoid with exactly 3 input params.")
        FUNCTOID_BITMAP(IDB_FUNCTOID_[!UpperShortName])   // have one FUNCTOID_BITMAP entry for the tool palette image
        FUNCTOID_OUT(CONNECT_TYPE_ALL)              // have one FUNCTOID_OUT entry for output parameter
        FUNCTOID_IN(CONNECT_TYPE_ALL_EXCEPT_RECORD) // have one FUNCTOID_IN entry for each fixed input parameter
        FUNCTOID_IN(CONNECT_TYPE_ALL_EXCEPT_RECORD) 
        FUNCTOID_IN(CONNECT_TYPE_ALL_EXCEPT_RECORD)
        FUNCTOID_IMPL(SCRIPT_CATEGORY_JSCRIPT, GetFunctoidImpl1) // 2nd param is member function of [!ClassName]
   END_FUNCTOID

   BEGIN_FUNCTOID(L"[!ShortName] #2", FUNC_CATEGORY_UNKNOWN)
        FUNCTOID_TOOLTIP(L"Custom functoid with at least 1 input param.")
        FUNCTOID_BITMAP(IDB_FUNCTOID_[!UpperShortName])   // have one FUNCTOID_BITMAP entry for the tool palette image
        FUNCTOID_OUT(CONNECT_TYPE_ALL)              // have one FUNCTOID_OUT entry for output parameter
        FUNCTOID_IN(CONNECT_TYPE_ALL_EXCEPT_RECORD) // have one FUNCTOID_IN entry for each fixed input parameter
        FUNCTOID_IN_OPTIONAL(CONNECT_TYPE_ALL_EXCEPT_RECORD) // have one catch-all for optional input parameters
        FUNCTOID_IMPL(SCRIPT_CATEGORY_VBSCRIPT, GetFunctoidImpl2) // 2nd param is member function of [!ClassName]
   END_FUNCTOID
END_FUNCTOID_MAP

[!crlf]
BSTR [!ClassName]::GetFunctoidImpl1 ( long nParameters )
{
    wchar_t wsz[4096];
    ::wcscpy(wsz, L"function [!ShortName]1 ( ");
    for ( int i = 0;  i < nParameters;  ++ i )
        ::swprintf(wsz+::wcslen(wsz), L"%s%d", i?L", ":L"", 1+i);
    ::wcscat(wsz, L" )\r\n");
    ::swprintf(wsz+::wcslen(wsz), L"{\r\n   return '[!ShortName] #1';");
    ::wcscat(wsz, L"\r\n}\r\n");
    return ::SysAllocString(wsz);
}

[!crlf]
BSTR [!ClassName]::GetFunctoidImpl2 ( long nParameters )
{
    wchar_t wsz[4096];
    ::wcscpy(wsz, L"function [!ShortName]2 ( ");
    for ( int i = 0;  i < nParameters;  ++ i )
        ::swprintf(wsz+::wcslen(wsz), L"%sx%d", i?L", ":L"", 1+i);
    ::wcscat(wsz, L" )\r\n");
    ::swprintf(wsz+::wcslen(wsz), L"\r\n   [!ShortName]2 = \"[!ShortName] #2\"");
    ::wcscat(wsz, L"\r\n}end function\r\n");
    return ::SysAllocString(wsz);
}
