// FormPostParser.h : Declaration of the CFormPostParser

#ifndef __FORMPOSTPARSER_H_
#define __FORMPOSTPARSER_H_

#include "resource.h"       // main symbols

// includes from BizTalk SDK from "Program Files\Microsoft BizTalk Server\SDK\Include"
#include <BTSParserComps.h> // for IBizTalkParserComponent interface
#include <bts_sdk_guids.h>  // for guids for interfaces and categories

// includes from STL
#include <vector>

#ifndef _CPPUNWIND
#pragma message("***************************************************************************************************")
#pragma message("*** Exception handling must be enabled for the STL classes used here.")
#pragma message("***************************************************************************************************")
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormPostParser
class ATL_NO_VTABLE CFormPostParser : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CFormPostParser, &CLSID_FormPostParser>,
	public IDispatchImpl<IFormPostParser, &IID_IFormPostParser, &LIBID_FORMPOSTBATCHPARSERLib>,
    public IBizTalkParserComponent
{
public:
	CFormPostParser()
	:   m_pwchStream(0)
	{
	}
    void FinalRelease ( void )
    {
        // cleanup copy of stream; assumes that each interchange gets a fresh coclass instance
        //  so that end of parsing does a final release
        delete[] (BYTE*)m_pwchStream;
        m_pwchStream = 0;
    }

DECLARE_REGISTRY_RESOURCEID(IDR_FORMPOSTPARSER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

// BizTalk requires a COM category for custom parsers
BEGIN_CATEGORY_MAP(CFormPostParser)
	IMPLEMENTED_CATEGORY(CATID_BIZTALK_COMPONENT)
     IMPLEMENTED_CATEGORY(CATID_BIZTALK_PARSER)
END_CATEGORY_MAP()

BEGIN_COM_MAP(CFormPostParser)
	COM_INTERFACE_ENTRY(IBizTalkParserComponent)
	COM_INTERFACE_ENTRY(IFormPostParser)
END_COM_MAP()

// IBizTalkParserComponent interface
public:
	STDMETHOD(ProbeInterchangeFormat)(IStream * pstmData, BOOL bFromFile, BSTR bstrEnvName, IStream * pstmReceiptData, BSTR * pbstrFormat);
	STDMETHOD(GetInterchangeDetails)(IDictionary * pdict);
	STDMETHOD(GroupsExist)(BOOL * pbGroupsExist);
	STDMETHOD(GetGroupDetails)(IDictionary * pdict);
	STDMETHOD(GetGroupSize)(long * pnGroupSize, BOOL * pbLastGroup);
	STDMETHOD(GetNextDocument)(IDictionary * pdict, BSTR bstrDocName, BOOL * pbDocIsValid, BOOL * pbLastDocument, enum GeneratedReceiptLevel * pnReceiptGenerated, BOOL * pbDocIsReceipt, BSTR * pbstrCorrelationCompProgID);
	STDMETHOD(GetNativeDocumentOffsets)(BOOL * pbSizeFromXMLDoc, LARGE_INTEGER * pnStartOffset, long * pnDocLength);

private:
    CComPtr<IStream> m_spstmData; // holds stream for data to parse; initialized in ProbeInterchangeFormat()
    wchar_t * m_pwchStream; // holds cache of entire stream contents; used for parsing buffer
    typedef std::vector<wchar_t*> DocList;
    DocList m_docs;
    DocList::iterator m_docpos;

// IFormPostParser
public:
};

#endif //__FORMPOSTPARSER_H_
